// src/backend/dummy_policy.cc - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "dummy_policy.hh"

using namespace std;
using namespace sgpem;

DummyPolicy::~DummyPolicy()
{
}

void
DummyPolicy::configure()
{
	_id = 100;
	_parameters.clear();
	_parameters.register_int("var1", 0, 10, true, 5);
	_parameters.register_int("var2", -100, +100, false);
	_parameters.register_float("kernel", 0, 10, true, 3.1415);
	_parameters.register_float("multiplier", -100000, 100000, true, 1000);
	_parameters.register_string("che_ne_so", true);
	
}

Glib::ustring
DummyPolicy::get_description() const
{
	return "This is a dummy policy implemented in C++. It is just needed as a debug stub.";
}

bool
DummyPolicy::is_pre_emptive() const
{
	return true;
}

int				
DummyPolicy::get_time_slice() const
{
	return _time_slice;
}

void				
DummyPolicy::set_time_slice( const int& i)
{
	_time_slice = i;
}

void
DummyPolicy::sort_queue(sgpem::Scheduler::event) const
{
	return;
}
