// src/backend/observedSubject.cc - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "observed_subject.hh"
using namespace std;
using namespace sgpem;


ObservedSubject::~ObservedSubject() 
{
}

/**
   Calls update() in each Observer
*/
void 
ObservedSubject::notify()
{
  for(vector<Observer*>::iterator i = _attached.begin(); i < _attached.end(); i++)
      (*i)->update();
  
}

/**
   Attachs an Observer to this ObservedSubject.
*/
void 
ObservedSubject::attach(Observer* o)
{
  _attached.push_back(o);
}

/**
   Detachs the observer from this ObservedSubject.
*/

bool 
ObservedSubject::detach(Observer* o)
{
  vector<Observer*>::iterator i = find(_attached.begin(), _attached.end(), o);
  if (i == _attached.end())
    return false;
	
  _attached.erase(i);	// FOUND and POPPED
  return true;
}


