// src/backend/process.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef PROCESS_HH
#define PROCESS_HH 1

#include "config.h"
#include "gettext.h"
#include "glibmm/ustring.h"

#include "schedulable.hh"

namespace sgpem
{
  class Process;

  /** \brief Represents a program in execution.
  
      It IS a Schedulable object.
  */
  class SG_DLLEXPORT Process : public Schedulable 
  {
  public:
    /** \brief Creates a new object with the given parameters. */
    Process(const Glib::ustring& name, const unsigned int& arrival, const unsigned int& total, const int& priority);
    /** \brief Destructor. */
    ~Process();
    /** \brief Returns a string describing the type of the object. */
    Glib::ustring	get_type() const;
		
  private:
  };
    
}

#endif

