// src/backend/user_interrupt_exception.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

// Warning! This exception will be thrown across different libraries.
// It could be necessary to do dynamic type-checking when 
// catching it (with typeinfo).

#ifndef USER_INTERRUPT_EXCEPTION
#define USER_INTERRUPT_EXCEPTION 1

#include "config.h"

#include <stdexcept>

namespace sgpem {
    class UserInterruptException;

    class SG_DLLEXPORT UserInterruptException : public std::runtime_error
    {
    public:
	UserInterruptException(const char* msg = "");
	virtual ~UserInterruptException() throw ();

    private:
    };
} //~ namespace sgpem

#endif
